﻿Imports DPG10Lib.Root


Public Class Form1

Private m_Lib As DPG10Lib.Root


Public Sub MessageOut(ByVal pMsg As String)
    While pMsg.EndsWith(vbCrLf)
        pMsg = pMsg.Remove(pMsg.Length - 2)
    End While
    If Not pMsg.EndsWith(vbCrLf) Then pMsg &= vbCrLf
    Me.TextBox1.AppendText(pMsg)
End Sub


Private Sub ShowMeasurement(ByVal pMeasurement As DPG10Lib.Measurement)
    Dim IndUnit, s As String, Current, Inductance As Single
    Dim MeaAvail As Boolean
    Dim i As Integer

    MeaAvail = pMeasurement.Linc_I_x.Count > 0

    IndUnit = "H"

    If MeaAvail Then
        IndUnit = IndUnitFromMultiplier(pMeasurement.Multiplier_L)
        s = String.Format("I[A]   L[{0}]", IndUnit)
        TextBox2.AppendText(s & vbCrLf & vbCrLf)

        For i = 1 To pMeasurement.Linc_I_x.Count
            Current = pMeasurement.Linc_I_x(i)
             If Current <> 0 Then
                Inductance = pMeasurement.Linc_I_y(i)
                s = String.Format("{0:N}   {1:N}", Current, Math.Round(Inductance, 1))
                TextBox2.AppendText(s & vbCrLf)
            End If
        Next
    End If
End Sub


Private Function IndUnitFromMultiplier(ByVal pMultiplier As Integer) As String
    Dim Einheit As String
    Select Case pMultiplier
        Case 1000000000
            Einheit = "nH"
        Case 1000000
            Einheit = "µH"
        Case 1000
            Einheit = "mH"
        Case Else
            Einheit = "H"
    End Select
    Return Einheit
End Function

Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
    Dim Mea As New DPG10Lib.Measurement
    On Error GoTo ProcExit
    Me.UseWaitCursor = True
    m_Lib.RunMeasurement(Me.txtCurrent.Text, txtVoltage.Text, txtPulseduration.Text, Mea, Me.ProgressBar1)
    ShowMeasurement(Mea)
ProcExit:
    Me.UseWaitCursor = False
End Sub



Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    m_Lib = New DPG10Lib.Root(Me)
    Timer1.Interval = 500
    Timer1.Enabled = True
    Application.DoEvents()
End Sub


Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
    Timer1.Enabled = False
    Me.Enabled = False
    m_Lib.Init()
    Me.Enabled = True
End Sub

End Class
