﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


namespace DPG10_Test_App_CS
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
            foreach (Control control in this.Controls)
            {
                control.Enabled = false;
            }
            //Old Constructor, still working. Uses default parameters 
            //m_lib = new DPG10Lib.Root(this);
            //new Constructor with varying parameters: Language default (english), show messageboxes
            m_lib = new DPG10Lib.Root(this, pUseModalDialogs: true);
            Timer t = new Timer();
            t.Tick += new EventHandler(t_Elapsed);
            t.Interval = 500;
            t.Start();       
        }


        private DPG10Lib.Root m_lib;
        private DPG10Lib.Measurement Mea;
        
        private void ShowMeasurement(DPG10Lib.Measurement pMeasurement)
        {
            string IndUnit = String.Empty;
            string s = String.Empty;
            float Current = 0.0f;
            float Inductance = 0.0f;
            
            bool MeaAvail = (pMeasurement.Linc_I_x.Count > 0) ? true : false;
            IndUnit = "H";

            if (MeaAvail)
            {
                IndUnit = IndUnitFromMultiplier(pMeasurement.Multiplier_L);
                s = string.Format("I[A]   L[{0}]", IndUnit);
                Mea_textBox.AppendText(s + "\n\n");

                for (int i = 1; i <= pMeasurement.Linc_I_x.Count; i++)
                {
                    try
                    {
                        Current = Convert.ToSingle(pMeasurement.Linc_I_x[i]); //Collection of key-value-pairs
                        if (Current != 0)
                        {
                            Inductance = (float)pMeasurement.Linc_I_y[i];
                            s = String.Format("{0:N}    {1:N}", Current, Math.Round(Inductance, 1));
                            Mea_textBox.AppendText(s + "\n");
                        }
                    }
                    catch (Exception e)
                    {
                        MessageBox.Show(e.Message + "\nSize of Collection: " + pMeasurement.Linc_I_x.Count + "\nOther Collection: " + pMeasurement.Linc_I_y.Count +
                            "\nActual index: " + i);
                    }
                }

            }

        }

        private string IndUnitFromMultiplier(int pMultiplier)
        {
            string Unit;
            switch (pMultiplier)
            {
                case 1000000000:
                    Unit = "nH";
                    break;
                case 1000000:
                    Unit = "µH";
                    break;
                case 1000:
                    Unit = "mH";
                    break;
                case 1:
                    Unit = "H";
                    break;
                default:
                    Unit = "?";
                    break;
            }
            return Unit;
        }
        
        private void t_Elapsed(object sender, EventArgs e)
        {            
            this.UseWaitCursor = true;
            Timer t = (Timer)sender;
            t.Stop();
            t.Dispose();
            this.m_lib.Init();
            foreach (Control control in this.Controls)
            {
                control.Enabled = true;
            }
            this.UseWaitCursor = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int mearesult;
            bool ok;

            Mea = new DPG10Lib.Measurement();
            Info_textBox.Clear();
            Mea_textBox.Clear();
            try
            {
                this.UseWaitCursor = true;
                mearesult = m_lib.RunMeasurement(Single.Parse(this.txtCurrent.Text), int.Parse(this.txtVoltage.Text), int.Parse(txtPulseduration.Text), ref Mea, this.progressBar1);
                this.UseWaitCursor = false;
                ok = (mearesult == 0);
                if (ok)
                    ShowMeasurement(Mea);
            }
            catch (Exception ex)
            {
                this.UseWaitCursor = false;
                MessageBox.Show("Something went wrong! Exception info:\n" + ex.Message + "\n" + ex.StackTrace);
            }
        }

        public void MessageOut(string pMsg)
        {
            this.Info_textBox.AppendText(pMsg + "\n");
        }
    }
}
